//  Copyright (C) 2007-2008  CEA/DEN, EDF R&D, OPEN CASCADE
//
//  Copyright (C) 2003-2007  OPEN CASCADE, EADS/CCR, LIP6, CEA/DEN,
//  CEDRAT, EDF R&D, LEG, PRINCIPIA R&D, BUREAU VERITAS
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
//
//  See http://www.salome-platform.org/ or email : webmaster.salome@opencascade.com
//
#ifndef SUIT_RESOURCEMGR_H
#define SUIT_RESOURCEMGR_H

#include "SUIT.h"

#include <QtxResourceMgr.h>

class SUIT_EXPORT SUIT_ResourceMgr : public QtxResourceMgr
{
public:
  SUIT_ResourceMgr( const QString&, const QString& = QString() );
  virtual ~SUIT_ResourceMgr();

  virtual QString version() const;
  void            setVersion( const QString& );

  QString         loadDoc( const QString&, const QString& ) const;

protected:
  virtual QString userFileName( const QString&, const bool = true ) const;
  virtual QString findAppropriateUserFile( const QString& ) const;
  virtual int     userFileId( const QString& ) const;

private:
  QString         myVersion;
};

#endif
