# --
# Copyright (C) CEA, EDF
# Author : Erwan ADAM (CEA)
# --

import unittest

from xsalome import XSalomeSession

class XDataTestTestCase(unittest.TestCase):
    def test(self):
        #
        salome = XSalomeSession(modules=["TECHOBJ"], logger=1)
        engine = salome.lcc.FindOrLoadComponent("FactoryServerPy", "TECHOBJ")
        self.failUnless(engine)
        from TECHOBJ_CORBA import TECHOBJ_Component
        engine = engine._narrow(TECHOBJ_Component)
        self.failUnless(engine)
        #
        l = [1, 2, 3]
        x = engine.newTestXListXInt(l, l)
        self.failUnlessEqual(x.getXlistXint(), l)
        #
        return
    pass

if __name__ == '__main__':
    unittest.main()
    pass
